﻿ReagentHelper2 = LibStub("AceAddon-3.0"):NewAddon("ReagentHelper2", "AceEvent-3.0", "AceConsole-3.0")
local TipHooker = LibStub:GetLibrary("LibTipHooker-1.1");
local AceConfig = LibStub("AceConfigDialog-3.0");
--local L = LibStub("AceLocale-3.0"):GetLocale("ReagentHelper2");
local BabbleClass = LibStub("LibBabble-Class-3.0"):GetLookupTable();
local BabbleInventory = LibStub("LibBabble-Inventory-3.0"):GetLookupTable();

local ToolTipList = {};
local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture;

function ReagentHelper2:OnInitialize()
	ReagentHelper2:RegisterChatCommand("rh", "ChatCommand")
	ReagentHelper2:RegisterChatCommand("rh2", "ChatCommand")
	ReagentHelper2:RegisterChatCommand("reagenthelper", "ChatCommand")
	ReagentHelper2:RegisterChatCommand("reagenthelper2", "ChatCommand")
	
	TipHooker:Hook(ReagentHelper2.ModifyItemTooltip, "item")
end

function ReagentHelper2:ChatCommand()
	
end

function ReagentHelper2:ModifyItemTooltip(tooltip, name, link)
	itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(name);
	ReagentHelper2:SearchReagentDB(itemName);
	table.sort(ToolTipList);
	for k, v in pairs(ToolTipList) do
		GameTooltip:AddLine(v);
	end
	itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = nil;
	ToolTipList = table.wipe(ToolTipList);
end

function ReagentHelper2:SearchReagentDB(ItemName)	
	for k, v in pairs(ReagentHelper2.Alchemy) do
		if (ItemName == v) then
			table.insert(ToolTipList, BabbleInventory["Alchemy"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Blacksmithing) do
		if (ItemName == v) then
			table.insert(ToolTipList, BabbleInventory["Blacksmithing"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Cooking) do
		if (ItemName == v) then
			table.insert(ToolTipList, BabbleInventory["Cooking"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Enchanting) do
		if (ItemName == v) then
			table.insert(ToolTipList, BabbleInventory["Enchanting"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Engineering) do
		if (ItemName == v) then
			table.insert(ToolTipList, BabbleInventory["Engineering"]);
		end
	end
	for k, v in pairs(ReagentHelper2.FirstAid) do
		if (ItemName == v) then
			table.insert(ToolTipList, BabbleInventory["First Aid"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Inscription) do
		if (ItemName == v) then
			table.insert(ToolTipList, BabbleInventory["Inscription"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Jewelcrafting) do
		if (ItemName == v) then
			table.insert(ToolTipList, BabbleInventory["Jewelcrafting"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Leatherworking) do
		if (ItemName == v) then
			table.insert(ToolTipList, BabbleInventory["Leatherworking"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Mining) do
		if (ItemName == v) then
			--table.insert(ToolTipList, BabbleInventory["Mining"]);
			table.insert(ToolTipList, "Mining");
		end
	end
	for k, v in pairs(ReagentHelper2.Tailoring) do
		if (ItemName == v) then
			table.insert(ToolTipList, BabbleInventory["Tailoring"]);
		end
	end
	
	for k, v in pairs(ReagentHelper2.Mage) do
		if (ItemName == v) then
			table.insert(ToolTipList, BabbleClass["Mage"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Priest) do
		if (ItemName == v) then
			table.insert(ToolTipList, BabbleClass["Priest"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Warlock) do
		if (ItemName == v) then
			table.insert(ToolTipList, BabbleClass["Warlock"]);
		end
	end
	for k, v in pairs(ReagentHelper2.DeathKnight) do
		if (ItemName == v) then
			table.insert(ToolTipList, BabbleClass["Deathknight"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Druid) do
		if (ItemName == v) then
			table.insert(ToolTipList, BabbleClass["Druid"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Shaman) do
		if (ItemName == v) then
			table.insert(ToolTipList, BabbleClass["Shaman"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Paladin) do
		if (ItemName == v) then
			table.insert(ToolTipList, BabbleClass["Paladin"]);
		end
	end
end